import random, datetime, math

from cocos.director import director
from cocos.layer import Layer,ColorLayer
from cocos.scene import Scene
from cocos.sprite import Sprite
from cocos.scenes.transitions import *
from cocos.actions import *

from cocos.menu import *
from cocos.text import *

import pygame
import config
from bg_layer import BGLayer
from screen_config import ConfigMenu
from menu_back import BackMenu
from menu_game_ready import ReadyMenu

class MainMenu( Menu ):

    def __init__(self):
        super( MainMenu, self).__init__() 
        
        self.menu_valign = BOTTOM
        #self.font_item['color'] = (32,16,32,255)
        self.font_item['font_size'] = 16
        self.font_item['color'] = (189,190,190,255)
        self.font_item_selected['color'] = (128,16,32,255)
        self.font_item_selected['font_size'] = 24
       
        items = []

        items.append( MenuItem('PLAY', self.on_play) )
        #items.append( MenuItem('SCORES', self.on_scores) )
        items.append( MenuItem('SETTINGS', self.on_settings) )
        items.append( MenuItem('CREDITS', self.on_credits) )
        items.append( MenuItem('QUIT', self.on_quit) )

        self.create_menu( items)
        
        # Spacing
        """    
        pos = 0
        for menuItem in items:
            menuItem.y =  - pos*20
            pos += 1
        """
            
    def on_enter(self):
        super(MainMenu, self).on_enter() 
               
    def on_play( self ):
        director.push(Scene (BGLayer("menu"),  ReadyMenu()))
        
    def on_scores( self ):
        pass #director.push(Scene (BGLayer("scores"), ScoresLayer(), BackMenu()) )
        
    def on_settings( self ):
        director.push(Scene (BGLayer("menu"),  ConfigMenu()))
        
        
    def on_credits( self ):
        director.push(Scene (BGLayer("credits_bg"), BackMenu()) )

    def on_quit(self):
        pyglet.app.exit()
        
